import { defineComponent as _, inject as de, computed as te, openBlock as V, createElementBlock as I, normalizeClass as K, renderSlot as z, ref as k, createElementVNode as N, unref as C, toDisplayString as U, Fragment as q, renderList as Q, withModifiers as W, createTextVNode as Z, normalizeStyle as le, createCommentVNode as Y, withKeys as J, withDirectives as ie, isRef as ee, vModelText as ue, nextTick as A, provide as se, createBlock as ce, withCtx as ae, createVNode as pe, getCurrentInstance as fe } from "vue";
const ne = Symbol("SELECTED_PROVIDE");
let ge = { checkboxId: 0 };
const me = ["disabled"], he = /* @__PURE__ */ _({
  __name: "CButton",
  props: {
    type: { default: "default" },
    disabled: { type: Boolean, default: !1 },
    selectable: { type: Boolean, default: !1 },
    modelValue: { type: Boolean, default: !1 },
    data: { default: void 0 }
  },
  emits: {
    click: (p) => !0,
    "update:model-value": (p) => !0
  },
  setup(p, { emit: a }) {
    const l = p, t = a;
    let e = de(ne, null);
    const c = te(() => {
      if (e) {
        if (e.selectMode == "single")
          return e.value == l.data;
        if (e.selectMode == "multiple")
          return e.value.indexOf(l.data) != -1;
      } else
        return l.selectable ? l.modelValue : !1;
    });
    function m(S) {
      e && e.change(l.data, !c.value), !l.disabled && l.selectable && t("update:model-value", !c.value), t("click", S);
    }
    return (S, y) => (V(), I("button", {
      class: K([
        "c-button-" + S.type + (S.disabled ? "-disabled" : ""),
        c.value ? "c-button-" + S.type + "-selected" : ""
      ]),
      disabled: S.disabled,
      onClick: m
    }, [
      z(S.$slots, "default")
    ], 10, me));
  }
}), ve = ["id", "value", "disabled"], De = ["for"], be = /* @__PURE__ */ _({
  __name: "CCheckBox",
  props: {
    disabled: { type: Boolean, default: !1 },
    modelValue: { default: "false" },
    label: { default: "" }
  },
  emits: {
    "update:model-value": (p) => !0
  },
  setup(p, { emit: a }) {
    let l = k("c-check-box-" + (++ge.checkboxId).toString());
    const t = a;
    function e(c) {
      t("update:model-value", c.target.value);
    }
    return (c, m) => (V(), I("div", null, [
      N("input", {
        id: C(l),
        type: "checkbox",
        value: c.modelValue,
        disabled: c.disabled,
        class: K([
          "c-check-box" + (c.disabled ? "-disabled" : "")
        ]),
        onInput: e
      }, null, 42, ve),
      N("label", { for: C(l) }, U(c.label), 9, De)
    ]));
  }
}), Se = /* @__PURE__ */ _({
  __name: "CGroup",
  props: {
    orientation: { default: "landscape" }
  },
  setup(p) {
    return (a, l) => (V(), I("div", {
      class: K(["c-group-" + a.orientation])
    }, [
      z(a.$slots, "default")
    ], 2));
  }
});
class re {
  winId = $.instance.winId;
  widgetId;
  widgetType;
  list = [];
}
class H {
  /**
   * 拖入的数据点
   */
  index;
  /**
   * 数据的parent对象，一般是Array
   */
  parent;
  /**
   * 窗口id
   */
  winId = $.instance.winId;
  /**
   * 组件id
   */
  widgetId;
  /**
   * 组件的类型
   */
  widgetType;
}
class $ {
  static instance = new $();
  _winId = (/* @__PURE__ */ new Date()).getTime();
  /**
   * 当前窗口ID，表示数据来源的窗口。
   */
  get winId() {
    return this._winId;
  }
  _widgetId = 0;
  /**
   * 生成新的控件ID，用于标识数据来月的控件。
   */
  get widgetId() {
    return ++this._widgetId;
  }
  /**
   * 验证是否为DragData
   * @param data 
   */
  getDragData(a) {
    if (a[0] != "{")
      return null;
    try {
      let l = JSON.parse(a);
      if (l.winId != null && l.widgetId != null)
        return l;
    } catch {
      return null;
    }
    return null;
  }
  /**
   * 如果是当前窗口发起的拖拽，则保存当前的拖拽信息
   */
  currentDragData;
}
const we = ["onClick", "draggable", "onDragstart", "onDragover", "onDragleave", "onDrop", "onDragend"], ye = {
  key: 0,
  class: "c-list-input"
}, Ve = /* @__PURE__ */ _({
  __name: "CList",
  props: {
    dataSource: {},
    modelValue: {},
    bindKey: { default: "" },
    multiChoice: { type: Boolean, default: !1 },
    hideBorder: { type: Boolean, default: !1 },
    itemDraggable: { type: Boolean, default: !1 }
  },
  emits: {
    "update:model-value": (p) => !0,
    submit: (p) => !0,
    itemdragstart: (p, a) => !0,
    itemdropallow: (p, a, l) => !0,
    itemdrop: (p, a, l) => !0
  },
  setup(p, { emit: a }) {
    const l = k(null), t = p;
    let e = k(!1), c = k(0), m = k(null), S = $.instance.widgetId;
    const y = a;
    function B(d, f, g) {
      if (t.multiChoice) {
        let o = null;
        if (d.shiftKey)
          if (m.value == null)
            o = [f], m.value = f;
          else {
            o = [];
            let u = !1, D = m.value, M = f;
            t.dataSource.indexOf(m.value) > t.dataSource.indexOf(f) && (D = f, M = m.value);
            for (let F = 0; F < t.dataSource.length; F++) {
              let n = t.dataSource[F];
              n == D ? u = !0 : n == M && (u = !1), (u || n == M) && o.push(n);
            }
          }
        else if (d.ctrlKey) {
          const u = t.modelValue;
          o = u.concat(), u.indexOf(f) == -1 ? (o.push(f), m.value = f) : (o.splice(o.indexOf(f), 1), m.value = null);
        } else
          o = [f], m.value = f;
        o != null && y("update:model-value", o);
      } else
        y("update:model-value", f), s();
    }
    function E(d, f, g) {
      let o = new re();
      o.widgetType = "c-list", o.widgetId = S;
      let u;
      if (t.multiChoice) {
        const D = t.modelValue;
        D == null || D.indexOf(f) == -1 ? (u = [f], y("update:model-value", u)) : u = D;
      } else
        t.modelValue != f ? (u = f, y("update:model-value", u)) : u = t.modelValue;
      if (t.multiChoice)
        for (let D of u)
          o.list.push({
            data: D,
            index: t.dataSource.indexOf(D),
            parent: t.dataSource
          });
      else
        o.list.push({
          data: u,
          index: g,
          parent: t.dataSource
        });
      y("itemdragstart", d, o), !d.defaultPrevented && d.dataTransfer && (d.dataTransfer.dropEffect = "move", d.dataTransfer.setData(
        "application/json",
        JSON.stringify(o)
      ), d.dataTransfer.setDragImage(d.target, 0, 0), $.instance.currentDragData = o);
    }
    function R(d, f, g) {
      let o = j(d, g), u = new H();
      u.widgetType = "c-list", u.widgetId = S, u.index = o.index, u.parent = t.dataSource, y(
        "itemdropallow",
        d,
        u,
        $.instance.currentDragData
      ), d.defaultPrevented && (c.value = o.top, e.value = !0);
    }
    function P(d, f, g) {
      e.value = !1;
    }
    function O(d, f, g) {
      e.value = !1;
      let o = j(d, g), u = new H();
      u.widgetType = "c-list", u.widgetId = S, u.index = o.index, u.parent = t.dataSource, y(
        "itemdrop",
        d,
        u,
        $.instance.currentDragData
      );
    }
    function G(d, f, g) {
      $.instance.currentDragData = void 0;
    }
    function j(d, f) {
      let g = d.currentTarget, o = g.getBoundingClientRect(), u = g.parentElement.getBoundingClientRect(), D = o.top - u.top + g.parentElement.scrollTop;
      return d.clientY > o.top + o.height / 2 ? { index: f + 1, top: D + o.height } : { index: f, top: D };
    }
    var r = "";
    function h(d) {
      if (!(d.ctrlKey || d.altKey || d.metaKey || d.shiftKey))
        if (d.code == "ArrowUp" || d.code == "ArrowDown") {
          if (t.modelValue == null)
            t.multiChoice ? y("update:model-value", [t.dataSource[0]]) : y("update:model-value", t.dataSource[0]), l.value.scrollTop = 0;
          else {
            let f = null;
            t.multiChoice ? f = t.modelValue[0] : f = t.modelValue;
            let g = t.dataSource.indexOf(f), o = d.code == "ArrowUp" ? g - 1 : g + 1, u = t.dataSource[o];
            u && (t.multiChoice ? y("update:model-value", [u]) : y("update:model-value", u), l.value.children[o].scrollIntoView({
              block: "nearest"
              // behavior: "smooth"//不要动画效果更好
            }));
          }
          d.preventDefault();
        } else if (d.code >= "KeyA" && d.code <= "KeyZ" || d.code >= "Digit0" && d.code <= "Digit9" || d.code >= "Numpad0" && d.code <= "Numpad9") {
          let f = d.code.replace(/Key|Digit|Numpad/g, "");
          r += f, x();
        } else
          d.code == "Enter" ? r != "" ? x() : s() : d.code == "Backspace" && r != "" ? (r = r.substr(0, r.length - 1), r != "" && x()) : d.code == "Escape" && (r = "");
    }
    function s() {
      y("submit", t.modelValue);
    }
    function x() {
      let d = [], f = 0;
      t.multiChoice ? f = t.modelValue == null ? 0 : t.dataSource.indexOf(t.modelValue[0]) + 1 : f = t.modelValue == null ? 0 : t.dataSource.indexOf(t.modelValue) + 1, f >= l.value.children.length && (f = 0);
      for (let g = f; g < l.value.children.length; g++)
        d.push(l.value.children[g]);
      for (let g = 0; g < f; g++)
        d.push(l.value.children[g]);
      for (let g of d)
        if ((g.textContent || "").replace(/(?![A-Z|a-z|0-9])/g, "").toUpperCase().indexOf(r) != -1) {
          let u = t.dataSource[Array.prototype.indexOf.call(l.value.children, g)];
          t.multiChoice ? y("update:model-value", [u]) : y("update:model-value", u), g.scrollIntoView({ block: "nearest" });
          break;
        }
    }
    return (d, f) => (V(), I("div", {
      class: K(["c-list-out-box", { "c-list-no-border": d.hideBorder }]),
      tabindex: "0",
      onKeydown: h
    }, [
      N("div", {
        class: K(["c-list-in-box", { "c-list-no-border": d.hideBorder }]),
        ref_key: "list",
        ref: l
      }, [
        (V(!0), I(q, null, Q(d.dataSource, (g, o) => (V(), I("div", {
          key: d.bindKey == "" ? "k" + o : g[d.bindKey],
          class: K(["c-list-item", { "c-list-item-sel": d.multiChoice ? d.modelValue.indexOf(g) != -1 : d.modelValue == g }]),
          onClick: W((u) => B(u, g), ["left"]),
          draggable: d.itemDraggable,
          onDragstart: (u) => E(u, g, o),
          onDragover: (u) => R(u, g, o),
          onDragleave: (u) => P(),
          onDrop: (u) => O(u, g, o),
          onDragend: (u) => G()
        }, [
          z(d.$slots, "item", {
            item: g,
            index: o
          }, () => [
            Z(U(o + ":" + JSON.stringify(g)), 1)
          ])
        ], 42, we))), 128)),
        C(e) ? (V(), I("div", {
          key: 0,
          class: "c-list-drop-view",
          style: le({ top: C(c) + "px" })
        }, null, 4)) : Y("", !0)
      ], 2),
      C(r) != "" ? (V(), I("label", ye, U(C(r)), 1)) : Y("", !0)
    ], 34));
  }
}), Ce = ["tabindex", "disabled"], Ie = { class: "c-number-input-label" }, xe = { class: "c-number-input-value" }, ke = /* @__PURE__ */ _({
  __name: "CNumberInput",
  props: {
    label: { default: "" },
    modelValue: { default: 0 },
    disabled: { type: Boolean, default: !1 },
    minValue: {},
    maxValue: {},
    step: { default: 1 }
  },
  emits: {
    "update:model-value": (p) => !0
  },
  setup(p, { emit: a }) {
    var l = "1234567890.-";
    let t = p, e = k(t.modelValue), c = k(!1), m = k("");
    const S = k(null), y = k(null);
    function B(o) {
      return t.minValue != null && (o = Math.max(t.minValue, o)), t.maxValue != null && (o = Math.min(t.maxValue, o)), o;
    }
    function E(o, u) {
      let D = (F) => {
        o(F);
      }, M = (F) => {
        u(F), document.removeEventListener("mousemove", D), document.removeEventListener("mouseup", M);
      };
      document.addEventListener("mousemove", D), document.addEventListener("mouseup", M);
    }
    function R(o) {
      o();
      let u, D = setTimeout(() => {
        u = setInterval(() => {
          o();
        }, 10);
      }, 500), M = (F) => {
        clearInterval(u), clearTimeout(D), document.removeEventListener("mouseup", M);
      };
      document.addEventListener("mouseup", M);
    }
    function P(o) {
      if (t.disabled)
        return;
      let u = o.clientX, D = e.value;
      E(
        (M) => {
          let n = (M.clientX - u) * 2 * t.step / 10, i = B(D + n);
          e.value = Math.floor(i / t.step) * t.step, r("update:model-value", e.value);
        },
        (M) => {
        }
      );
    }
    function O(o) {
      o.stopPropagation(), o.stopImmediatePropagation(), !t.disabled && R(() => {
        e.value = B(e.value - t.step), r("update:model-value", e.value);
      });
    }
    function G(o) {
      o.stopPropagation(), o.stopImmediatePropagation(), !t.disabled && R(() => {
        e.value = B(e.value + t.step), r("update:model-value", e.value);
      });
    }
    const j = te(() => t.maxValue != null && t.minValue != null ? (e.value - t.minValue) / (t.maxValue - t.minValue) : 0), r = a;
    function h() {
      e.value = B(e.value - t.step), r("update:model-value", e.value);
    }
    function s() {
      e.value = B(e.value + t.step), r("update:model-value", e.value);
    }
    async function x() {
      c.value = !0, m.value = e.value.toString(), await A(), y.value.focus();
    }
    async function d() {
      c.value != !1 && (c.value = !1, m.value = "", await A(), S.value.focus());
    }
    async function f() {
      c.value = !1;
      let o = parseFloat(m.value);
      (o == null || isNaN(o)) && (o = 0), o = B(o), e.value = Math.floor(o / t.step) * t.step, r("update:model-value", e.value), m.value = "", await A(), S.value.focus();
    }
    async function g(o) {
      l.indexOf(o.key) != -1 && (c.value = !0, await A(), y.value.focus());
    }
    return (o, u) => C(c) ? ie((V(), I("input", {
      key: 1,
      ref_key: "editor",
      ref: y,
      type: "text",
      autocomplete: "off",
      "onUpdate:modelValue": u[0] || (u[0] = (D) => ee(m) ? m.value = D : m = D),
      class: "c-number-input",
      onKeydown: [
        J(d, ["esc"]),
        J(f, ["enter"])
      ],
      onBlur: d
    }, null, 544)), [
      [ue, C(m)]
    ]) : (V(), I("div", {
      key: 0,
      ref_key: "view",
      ref: S,
      class: K([C(t).disabled ? "c-number-input-disabled" : "c-number-input"]),
      style: le({ "--progress": j.value * 100 + "%" }),
      onMousedown: P,
      tabindex: C(t).disabled ? "" : 0,
      onKeydown: [
        J(h, ["left"]),
        J(s, ["right"]),
        J(x, ["enter"]),
        g
      ],
      disabled: C(t).disabled
    }, [
      N("label", {
        class: "c-number-input-left",
        onMousedown: O
      }, "◀", 32),
      N("label", Ie, U(C(t).label) + ":", 1),
      N("label", xe, U(C(e)), 1),
      N("label", {
        class: "c-number-input-right",
        onMousedown: G
      }, "▶", 32)
    ], 46, Ce));
  }
}), Oe = /* @__PURE__ */ _({
  __name: "CSelectableGroup",
  props: {
    orientation: { default: "landscape" },
    selectMode: { default: "single" },
    modelValue: { default: void 0 }
  },
  emits: {
    "update:model-value": (p) => !0
  },
  setup(p, { emit: a }) {
    const l = p, t = a;
    return se(ne, {
      change(e, c) {
        if (l.selectMode == "single")
          c && t("update:model-value", e);
        else if (c) {
          if (!l.modelValue || l.modelValue.indexOf(e) == -1) {
            let m = l.modelValue ? l.modelValue.slice() : [];
            m.push(e), t("update:model-value", m);
          }
        } else {
          let m = l.modelValue ? l.modelValue.filter((S) => S != e) : [];
          t("update:model-value", m);
        }
      },
      get selectMode() {
        return l.selectMode;
      },
      get value() {
        return l.selectMode == "single" || l.modelValue ? l.modelValue : [];
      }
    }), (e, c) => (V(), I("div", {
      class: K(["c-group-" + e.orientation])
    }, [
      z(e.$slots, "default")
    ], 2));
  }
}), Te = ["placeholder", "disabled", "rows", "value"], Ke = /* @__PURE__ */ _({
  __name: "CTextArea",
  props: {
    placeholder: { default: void 0 },
    disabled: { type: Boolean, default: !1 },
    minRows: { default: 1 },
    maxRows: {},
    modelValue: { default: "" }
  },
  emits: {
    "update:model-value": (p) => !0
  },
  setup(p, { emit: a }) {
    const l = p;
    let t = te(() => {
      let m = 0;
      for (let y of l.modelValue)
        y == `
` && m++;
      let S = Math.max(m, l.minRows);
      return l.maxRows && S > l.maxRows && (S = l.maxRows), S;
    });
    const e = a;
    function c(m) {
      e("update:model-value", m.target?.value || "");
    }
    return (m, S) => (V(), I("textarea", {
      placeholder: m.placeholder,
      autocomplete: "off",
      disabled: m.disabled,
      rows: C(t),
      class: K([
        "c-text-area" + (m.disabled ? "-disabled" : "")
      ]),
      value: m.modelValue,
      onInput: c
    }, null, 42, Te));
  }
}), Be = ["placeholder", "value", "disabled"], Ee = /* @__PURE__ */ _({
  __name: "CTextInput",
  props: {
    placeholder: { default: void 0 },
    disabled: { type: Boolean, default: !1 },
    modelValue: { default: "" }
  },
  emits: {
    "update:model-value": (p) => !0
  },
  setup(p, { emit: a }) {
    const l = a;
    function t(e) {
      l("update:model-value", e.target?.value || "");
    }
    return (e, c) => (V(), I("input", {
      type: "text",
      placeholder: e.placeholder,
      autocomplete: "off",
      value: e.modelValue,
      disabled: e.disabled,
      class: K([
        "c-text-input" + (e.disabled ? "-disabled" : "")
      ]),
      onInput: t
    }, null, 42, Be));
  }
});
class X {
  static bindKeyId = 0;
  /**
   * 唯一ID 方便vue渲染节点
   */
  bindKey = X.bindKeyId++;
  /**
   * 父节点
   */
  parent;
  /**
   * 子节点
   */
  children;
  /**
   * 允许拥有子节点
   */
  haveChildren;
  /**
   * 是否是已折叠的
   */
  isFolded = !0;
  /**
   * 所绑定的数据
   */
  data;
  /**
   * 获取下一项,无论节点是否打开
   */
  get next() {
    if (this.children && this.children.length > 0)
      return this.children[0];
    {
      let a, l = this;
      for (; a == null && l != null && l.parent != null; )
        a = l.parent.children[l.parent.children.indexOf(l) + 1], l = l.parent;
      return a;
    }
  }
  /**
   * 获取上一项,无论节点是否打开
   */
  get prev() {
    if (this.parent) {
      let a = this.parent.children[this.parent.children.indexOf(this) - 1];
      if (a) {
        for (; a.children; )
          a = a.children[a.children.length - 1];
        return a;
      } else
        return this.parent;
    }
  }
  /**
   * 获取下一项,节点必须打开才会进入子节点
   */
  get nextOpend() {
    if (!this.isFolded && this.children && this.children.length > 0)
      return this.children[0];
    {
      let a, l = this;
      for (; a == null && l != null && l.parent != null; )
        a = l.parent.children[l.parent.children.indexOf(l) + 1], l = l.parent;
      return a;
    }
  }
  /**
   * 获取上一项,节点必须打开才会进入子节点
   */
  get prevOpend() {
    if (this.parent) {
      let a = this.parent.children[this.parent.children.indexOf(this) - 1];
      if (a) {
        for (; !a.isFolded && a.children; )
          a = a.children[a.children.length - 1];
        return a;
      } else
        return this.parent;
    }
  }
  /**
   * 查找自己的索引全局索引
   */
  get index() {
    let a = this.prev, l = 0;
    for (; a != null; )
      l++, a = a.prev;
    return l;
  }
  /**
   * 向上打开所有节点
   */
  openToParent() {
    let a = this.parent;
    for (; a; )
      a.isFolded = !1, a = a.parent;
  }
  /**
   * 遍历节点，进行逻辑上的关闭操作 返回true则折叠，false则打开
   * @param logic 
   */
  fold(a) {
    if (this.isFolded = a(this.data), this.children)
      for (let l of this.children)
        l.fold(a);
  }
  /**
   * 将树打开到目标数据
   * @param data 
   */
  openTo(a) {
    let l = this.find(a);
    if (l) {
      let t = l;
      for (; t != null; )
        t.isFolded = !1, t = t.parent;
    }
    return l;
  }
  /**
   * 查找数据对应的树对象
   * @param data 
   */
  find(a) {
    if (this.data == a)
      return this;
    if (this.children) {
      for (let l of this.children) {
        let t = l.find(a);
        if (t)
          return t;
      }
      return;
    } else
      return;
  }
  /**
   * 获取共有几个父节点
   */
  get parentCount() {
    let a = this.parent, l = 0;
    for (; a; )
      l++, a = a.parent;
    return l;
  }
  /**
   * 将原始数据转换成数据源数据，方便tree组件解析
   */
  static toDataSource(a, l) {
    let t = new X();
    if (t.data = a, a[l]) {
      t.children = [], t.haveChildren = !0;
      for (let e of a[l]) {
        let c = this.toDataSource(e, l);
        c.parent = t, t.children.push(c);
      }
    }
    return t;
  }
}
const Me = ["draggable"], $e = {
  key: 0,
  class: "tree-item-icon fa fa-file-o"
}, Fe = { key: 0 }, oe = /* @__PURE__ */ _({
  __name: "CTreeNode",
  props: {
    dataSource: {},
    modelValue: {},
    multiChoice: { type: Boolean, default: !1 },
    gap: { default: 0 },
    currentSelected: {},
    itemDraggable: { type: Boolean },
    widgetId: {}
  },
  emits: {
    change: (p) => !0,
    changeSel: (p) => !0,
    dragstart: (p, a, l) => !0,
    dragover: (p, a, l) => !0,
    dragleave: (p, a, l) => !0,
    drop: (p, a, l) => !0,
    dragend: (p, a, l) => !0,
    doubleClickItem: (p, a) => !0
  },
  setup(p, { expose: a, emit: l }) {
    const t = k([]), e = p, c = l;
    function m(r) {
      if (e.multiChoice) {
        let h = e.modelValue, s = null;
        if (r.shiftKey)
          if (e.currentSelected == null)
            s = [e.dataSource], c("changeSel", e.dataSource);
          else {
            s = [];
            let x = e.currentSelected, d = e.dataSource;
            for (x.index > d.index && (x = e.dataSource, d = e.currentSelected), s.push(x); x != null && x.next != d; )
              x = x.next, x && s.push(x);
            s.push(d);
          }
        else
          r.ctrlKey ? (s = h.concat(), h.indexOf(e.dataSource) == -1 ? (s.push(e.dataSource), c("changeSel", e.dataSource)) : (s.splice(s.indexOf(e.dataSource), 1), c("changeSel", null))) : (s = [e.dataSource], c("changeSel", e.dataSource));
        s != null && c("change", s);
      } else
        e.dataSource != e.modelValue && c("change", e.dataSource);
    }
    function S(r, h, s) {
      c(
        "dragstart",
        r,
        h || e.dataSource,
        s ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function y(r, h, s) {
      c(
        "dragover",
        r,
        h || e.dataSource,
        s ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function B(r, h, s) {
      c(
        "dragleave",
        r,
        h || e.dataSource,
        s ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function E(r, h, s) {
      c(
        "drop",
        r,
        h || e.dataSource,
        s ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function R(r, h, s) {
      c(
        "dragend",
        r,
        h || e.dataSource,
        s ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function P(r) {
      c("doubleClickItem", r, e.dataSource), r.defaultPrevented || (e.dataSource.isFolded = !e.dataSource.isFolded);
    }
    function O(r) {
      c("change", r);
    }
    function G(r) {
      c("changeSel", r);
    }
    function j(r, h) {
      c("doubleClickItem", r, e.dataSource);
    }
    return a({ childRefs: t }), (r, h) => (V(), I("div", null, [
      N("div", {
        class: K(["c-tree-item", { "c-tree-item-sel": r.multiChoice ? r.modelValue.indexOf(r.dataSource) != -1 : r.modelValue == r.dataSource }]),
        draggable: r.itemDraggable,
        onClick: h[1] || (h[1] = W((s) => m(s), ["left"])),
        onDblclick: h[2] || (h[2] = W((s) => P(s), ["left"])),
        onDragstart: h[3] || (h[3] = (s) => S(s)),
        onDragover: h[4] || (h[4] = (s) => y(s)),
        onDragleave: h[5] || (h[5] = (s) => B(s)),
        onDrop: h[6] || (h[6] = (s) => E(s)),
        onDragend: h[7] || (h[7] = (s) => R(s))
      }, [
        (V(!0), I(q, null, Q(r.gap, (s) => (V(), I("div", {
          key: s,
          class: "c-tree-gap gap-line"
        }))), 128)),
        r.dataSource.children != null && r.dataSource.children.length > 0 ? (V(), I("i", {
          key: 0,
          class: K(["tree-fold-icon fa", { "fa-chevron-down": !r.dataSource.isFolded, "fa-chevron-right": r.dataSource.isFolded }]),
          "aria-hidden": "true",
          onClick: h[0] || (h[0] = (s) => r.dataSource.isFolded = !r.dataSource.isFolded)
        }, null, 2)) : Y("", !0),
        N("div", {
          class: K(["c-tree-item-content", ["tree-node-id-" + r.dataSource.bindKey]])
        }, [
          z(r.$slots, "icon", { tree: r.dataSource }, () => [
            r.dataSource.children == null ? (V(), I("i", $e)) : Y("", !0)
          ]),
          z(r.$slots, "item", { tree: r.dataSource }, () => [
            Z(U(r.dataSource.bindKey), 1)
          ])
        ], 2)
      ], 42, Me),
      r.dataSource.children != null && r.dataSource.children.length > 0 && !r.dataSource.isFolded ? (V(), I("div", Fe, [
        (V(!0), I(q, null, Q(r.dataSource.children, (s) => (V(), ce(oe, {
          ref_for: !0,
          ref_key: "childRefs",
          ref: t,
          key: s.bindKey,
          dataSource: s,
          multiChoice: r.multiChoice,
          gap: r.gap + 1,
          modelValue: r.modelValue,
          currentSelected: r.currentSelected,
          widgetId: r.widgetId,
          itemDraggable: r.itemDraggable,
          onChange: O,
          onChangeSel: G,
          onDoubleClickItem: j,
          onDragstart: S,
          onDragover: y,
          onDragleave: B,
          onDrop: E,
          onDragend: R
        }, {
          item: ae((x) => [
            z(r.$slots, "item", {
              tree: x.tree
            }, () => [
              Z(U(x.tree.bindKey), 1)
            ])
          ]),
          _: 2
        }, 1032, ["dataSource", "multiChoice", "gap", "modelValue", "currentSelected", "widgetId", "itemDraggable"]))), 128))
      ])) : Y("", !0)
    ]));
  }
}), Re = {
  key: 0,
  class: "c-list-input"
}, Le = /* @__PURE__ */ _({
  __name: "CTree",
  props: {
    dataSource: {},
    modelValue: {},
    multiChoice: { type: Boolean, default: !1 },
    itemDraggable: { type: Boolean, default: !1 },
    hideBorder: { type: Boolean, default: !1 }
  },
  emits: {
    "update:model-value": (p) => !0,
    changeSel: (p) => !0,
    itemdragstart: (p, a) => !0,
    itemdropallow: (p, a, l) => !0,
    itemdrop: (p, a, l) => !0,
    drop: (p, a, l) => !0,
    dragend: (p, a, l) => !0,
    doubleClickItem: (p, a) => !0
  },
  setup(p, { expose: a, emit: l }) {
    const t = k(null), e = p;
    let c = k(!1), m = k(0), S = k(0), y = k(3), B = k(null), E = k(!1), R = k($.instance.widgetId);
    const P = k(null), O = l;
    function G(n) {
      O("update:model-value", n);
    }
    function j(n) {
      B.value = n;
    }
    function r(n, i) {
      O("doubleClickItem", n, e.dataSource);
    }
    function h(n, i) {
      if (n.dataSource == i)
        return n.$el;
      for (let b of n.childRefs) {
        let w = h(b, i);
        if (w)
          return w;
      }
    }
    async function s(n) {
      let i = n;
      for (; i != null; )
        i.isFolded = !1, i = i.parent;
      await A();
      let b = t.value?.childRefs[0], w = h(b, n);
      w && (P.value.scrollTop = w.offsetTop);
    }
    function x(n, i, b) {
      let w = new re();
      w.widgetType = "c-tree", w.widgetId = R.value;
      let v;
      if (e.multiChoice ? e.modelValue == null || e.modelValue.indexOf(i) == -1 ? (v = [i], O("update:model-value", v)) : v = e.modelValue : e.modelValue != i ? (v = i, O("update:model-value", i)) : v = e.modelValue, e.multiChoice)
        for (let T of v)
          w.list.push({
            data: T,
            index: T.parent ? T.parent.children.indexOf(T) : -1,
            parent: T.parent
          });
      else
        w.list.push({
          data: v,
          index: b,
          parent: v.parent
        });
      O("itemdragstart", n, w), !n.defaultPrevented && n.dataTransfer && (n.dataTransfer.dropEffect = "move", n.dataTransfer.setData(
        "application/json",
        JSON.stringify(w, (T, L) => T == "parent" && L instanceof X ? null : L)
      ), n.dataTransfer.setDragImage(n.target, 0, 0), $.instance.currentDragData = w);
    }
    function d(n, i, b) {
      let w = u(n, i, b), v = new H();
      v.widgetType = "c-tree", v.widgetId = R.value, v.index = w.index, v.parent = e.dataSource, O(
        "itemdropallow",
        n,
        v,
        $.instance.currentDragData
      ), n.defaultPrevented && (m.value = w.top, c.value = !0, y.value = w.height, S.value = w.gap);
    }
    function f(n, i) {
      c.value = !1;
    }
    function g(n, i, b) {
      c.value = !1;
      let w = u(n, i, b), v = new H();
      v.widgetType = "c-tree", v.widgetId = R.value, v.index = w.index, v.parent = w.target;
      let T = $.instance.currentDragData;
      if (T)
        for (let L = 0; L < T.list.length; L++)
          T.list[L].data == v.parent && (T.list.splice(L, 1), L--);
      O("itemdrop", n, v, T);
    }
    function o() {
      $.instance.currentDragData = void 0;
    }
    function u(n, i, b) {
      let v = n.currentTarget.getBoundingClientRect(), T = P.value.getBoundingClientRect(), L = v.top - T.top + P.value.scrollTop;
      return (i.haveChildren ? n.clientY > v.top + v.height / 4 * 3 : n.clientY >= v.top + v.height / 2) ? {
        index: !i.isFolded && i.haveChildren ? 0 : b + 1,
        //已经关闭说明是向下插入
        target: !i.isFolded && i.haveChildren ? i : i.parent ? i.parent : void 0,
        //如果自己没用parent则不操作
        top: L + v.height,
        height: 3,
        isPutIn: !1,
        gap: ((!i.isFolded && i.haveChildren ? 1 : 0) + i.parentCount) * 11
        //已经打开则只能插入在子集
      } : (i.haveChildren ? n.clientY < v.top + v.height / 4 : n.clientY < v.top + v.height / 2) ? {
        index: i.parent ? b : 0,
        target: i.parent ? i.parent : i,
        top: L,
        height: 3,
        isPutIn: !1,
        gap: i.parentCount * 11
      } : {
        index: i.children ? i.children.length : 0,
        target: i,
        top: L,
        height: v.height,
        isPutIn: !0,
        gap: 0
      };
    }
    let D = "";
    async function M(n) {
      let i = P.value;
      if (n.code == "ArrowUp" || n.code == "ArrowDown") {
        if (e.modelValue == null)
          e.multiChoice ? O("update:model-value", [e.dataSource]) : O("update:model-value", e.dataSource), i.scrollTop = 0;
        else {
          let b;
          e.multiChoice ? b = e.modelValue[0] : b = e.modelValue;
          let w = n.code == "ArrowUp" ? b.prevOpend : b.nextOpend;
          w && (e.multiChoice ? O("update:model-value", [w]) : O("update:model-value", w), w.openToParent()), await A();
          let v = i.querySelector(".c-tree-item-sel");
          v && v.scrollIntoView({
            block: "nearest"
            // behavior: "smooth"//不要动画效果更好
          });
        }
        n.preventDefault();
      } else if (n.code == "ArrowLeft" || n.code == "ArrowRight") {
        let b;
        e.multiChoice ? b = e.modelValue[0] : b = e.modelValue, b && (b.isFolded = n.code == "ArrowLeft"), n.preventDefault();
      } else if (n.code >= "KeyA" && n.code <= "KeyZ" || n.code >= "Digit0" && n.code <= "Digit9" || n.code >= "Numpad0" && n.code <= "Numpad9") {
        let b = n.code.replace(/Key|Digit|Numpad/g, "");
        console.log(b), D += b, F();
      } else
        n.code == "Enter" && D != "" ? F() : n.code == "Backspace" && D != "" ? (D = D.substr(0, D.length - 1), D != "" && F()) : n.code == "Escape" && (D = "");
    }
    async function F() {
      let n;
      e.multiChoice ? e.modelValue == null || e.modelValue.length == 0 ? n = e.dataSource : n = e.modelValue[0] : e.modelValue == null ? n = e.dataSource : n = e.modelValue, n.openToParent(), await A(), n.haveChildren && n.isFolded && (n.isFolded = !1, await A());
      let i = n.next;
      for (; i != n; ) {
        i == null && (i = e.dataSource);
        let b = fe()?.proxy?.$el.querySelector(".tree-node-id-" + i.bindKey);
        if ((b.textContent || "").replace(/(?![A-Z|a-z|0-9])/g, "").toUpperCase().indexOf(D) != -1) {
          e.multiChoice ? O("update:model-value", [i]) : O("update:model-value", i), b.scrollIntoView({ block: "nearest" });
          break;
        }
        i.haveChildren && i.isFolded && (i.isFolded = !1, await A()), i = i.next;
      }
    }
    return a({ scrollTo: s }), (n, i) => (V(), I("div", {
      class: K(["c-list-out-box", { "c-tree-show-line": C(E), "c-list-no-border": n.hideBorder }]),
      onMouseover: i[0] || (i[0] = (b) => ee(E) ? E.value = !0 : E = !0),
      onMouseleave: i[1] || (i[1] = (b) => ee(E) ? E.value = !1 : E = !1),
      tabindex: "0",
      onKeydown: M
    }, [
      N("div", {
        class: K(["c-list-in-box", { "c-list-no-border": n.hideBorder }]),
        ref_key: "inbox",
        ref: P
      }, [
        pe(oe, {
          ref_key: "treeRef",
          ref: t,
          dataSource: n.dataSource,
          multiChoice: n.multiChoice,
          modelValue: n.modelValue,
          currentSelected: C(B),
          widgetId: C(R),
          itemDraggable: n.itemDraggable,
          onChange: G,
          onChangeSel: j,
          onDoubleClickItem: r,
          onDragstart: x,
          onDragover: d,
          onDragleave: f,
          onDrop: g,
          onDragend: o,
          class: "c-tree-node"
        }, {
          item: ae(({ tree: b }) => [
            z(n.$slots, "item", { tree: b }, () => [
              Z(U(b.bindKey), 1)
            ])
          ]),
          _: 3
        }, 8, ["dataSource", "multiChoice", "modelValue", "currentSelected", "widgetId", "itemDraggable"]),
        C(c) ? (V(), I("div", {
          key: 0,
          class: "c-tree-drop-view",
          style: le({ top: C(m) + "px", "--gap-width": C(S), height: C(y) + "px" })
        }, null, 4)) : Y("", !0)
      ], 2),
      C(D) != "" ? (V(), I("label", Re, U(C(D)), 1)) : Y("", !0)
    ], 34));
  }
}), Pe = [he, be, Se, Ve, ke, Oe, Ke, Ee, Le], _e = (p) => {
  for (let a of Pe)
    p.component(a.name, a);
};
export {
  he as CButtonVue,
  be as CCheckBoxVue,
  Se as CGroupVue,
  Ve as CListVue,
  ke as CNumberInputVue,
  Oe as CSelectableGroupVue,
  Ke as CTextAreaVue,
  Ee as CTextInputVue,
  Le as CTreeVue,
  _e as install
};
//# sourceMappingURL=compactui2.es.js.map
